
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Activity_feed_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const activity_feed_items = await db.activity_feed_items.create(
            {
                id: data.id || undefined,
        
        category: data.category
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
        link_path: data.link_path
        ||
        null
            ,
            
        happened_at: data.happened_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await activity_feed_items.setTeam( data.team || null, {
            transaction,
        });
        
        await activity_feed_items.setActor( data.actor || null, {
            transaction,
        });
        
        await activity_feed_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return activity_feed_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const activity_feed_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                category: item.category
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
                link_path: item.link_path
            ||
            null
            ,
            
                happened_at: item.happened_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const activity_feed_items = await db.activity_feed_items.bulkCreate(activity_feed_itemsData, { transaction });

        // For each item created, replace relation files
        

        return activity_feed_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const activity_feed_items = await db.activity_feed_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        if (data.link_path !== undefined) updatePayload.link_path = data.link_path;
        
        
        if (data.happened_at !== undefined) updatePayload.happened_at = data.happened_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await activity_feed_items.update(updatePayload, {transaction});

        
        
        if (data.team !== undefined) {
            await activity_feed_items.setTeam(
              
              data.team,
              
              { transaction }
            );
        }
        
        if (data.actor !== undefined) {
            await activity_feed_items.setActor(
              
              data.actor,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await activity_feed_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return activity_feed_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const activity_feed_items = await db.activity_feed_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of activity_feed_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of activity_feed_items) {
                await record.destroy({transaction});
            }
        });


        return activity_feed_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const activity_feed_items = await db.activity_feed_items.findByPk(id, options);

        await activity_feed_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await activity_feed_items.destroy({
            transaction
        });

        return activity_feed_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const activity_feed_items = await db.activity_feed_items.findOne(
            { where },
            { transaction },
        );

        if (!activity_feed_items) {
            return activity_feed_items;
        }

        const output = activity_feed_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.team = await activity_feed_items.getTeam({
            transaction
        });
        
        
        output.actor = await activity_feed_items.getActor({
            transaction
        });
        
        
        output.organizations = await activity_feed_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.teams,
        as: 'team',
        
        where: filter.team ? {
          [Op.or]: [
            { id: { [Op.in]: filter.team.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.team.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'actor',
        
        where: filter.actor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.actor.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.actor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'activity_feed_items',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            
            if (filter.link_path) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'activity_feed_items',
                        'link_path',
                        filter.link_path,
                    ),
                };
            }
            

            
            

            
            if (filter.happened_atRange) {
                const [start, end] = filter.happened_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    happened_at: {
                    ...where.happened_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    happened_at: {
                    ...where.happened_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.category) {
                where = {
                    ...where,
                category: filter.category,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.activity_feed_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'activity_feed_items',
                        'summary',
                        query,
                    ),
                ],
            };
        }

        const records = await db.activity_feed_items.findAll({
            attributes: [ 'id', 'summary' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['summary', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.summary,
        }));
    }

    
};

